#include <bits/stdc++.h>
using namespace std;
struct point
{
    int x;
    int y;
};
int main()
{
    ios::sync_with_stdio(0);
    cin.tie(0);
    int n, a=INT_MAX, b=INT_MIN, c=INT_MIN, d=INT_MAX;
    int X[100000], Y[100000];
    point corner[3];
    cin >> n;
    for (int i=0; i<n; i++)
    {
        cin >> X[i] >> Y[i];
        a = min(a, Y[i]);
        b = max(b, X[i]);
        c = max(c, Y[i]);
        d = min(d, X[i]);
        if (i==0)
        {
            cout << 0 << endl;
            continue;
        }
        corner[0].x=a; corner[0].y=d;
        corner[1].x=a; corner[1].y=b;
        corner[2].x=c; corner[2].y=b;
        corner[3].x=c; corner[3].y=d;
        unsigned long long sum[3]={0};
        for (int j=0; j<=i; j++)
        {
            sum[0]+= abs(corner[0].x-X[j]) * abs(corner[0].y-Y[j]);
            sum[1]+= abs(corner[1].x-X[j]) * abs(corner[1].y-Y[j]);
            sum[2]+= abs(corner[2].x-X[j]) * abs(corner[2].y-Y[j]);
            sum[3]+= abs(corner[3].x-X[j]) * abs(corner[3].y-Y[j]);
        }
        cout << max(sum[0], max(sum[1], max(sum[2], sum[3]))) << endl;
    }
    return 0;
}